Index: applications/editors/josm/plugins/tcxplugin/build.xml
===================================================================
--- applications/editors/josm/plugins/tcxplugin/build.xml	(revision 12778)
+++ applications/editors/josm/plugins/tcxplugin/build.xml	(revision 12780)
@@ -1,108 +1,90 @@
 <project name="tcx-support" default="dist" basedir=".">
-  
-  <!-- josm "user home" directory depends on the platform used (windows has a different place than unix/linux) -->
-  <property environment="env"/>
-  <condition property="josm.home.dir" value="${env.APPDATA}/JOSM" else="${user.home}/.josm">
-    <and>
-      <os family="windows"/>
-    </and>
-  </condition>
-
-  <!-- compilation properties -->
-  <property name="josm.build.dir"	value="../../core"/>
-  <property name="josm.plugins.dir" value="${josm.home.dir}/plugins"/>
-  <property name="josm"			location="../../core/dist/josm-custom.jar" />
-  <property name="plugin.build.dir"	value="build"/>
-  <property name="plugin.dist.dir"	value="../../dist"/>
-  <property name="plugin.name"		value="${ant.project.name}"/>
-  <property name="plugin.jar"		value="../../dist/${plugin.name}.jar"/>
-
-  <property name="livegpsplugin.jar" value="../../dist/livegps.jar"/>
-  
-  <property name="plugin.description" value="Adds support for TCX files."/>
-  <property name="plugin.stage" value="100"/>
-  <property name="plugin.class" value="org.openstreetmap.josm.plugins.TcxPlugin"/>
-  
-  <!-- update site meta data -->
-  <property name="plugin.site.file" value="josm-site.xml"/>
-  <property name="plugin.site.description" value=""/>
-  <property name="plugin.site.url" value=""/>
-  <property name="plugin.site.upload.target" value=""/>
-
-  <property name="ant.build.javac.target" value="1.5"/>
-  
-	<!-- All jar files necessary to run only JOSM (no tests) -->
-	<fileset id="josm_required_libs" dir="lib">
-	</fileset>
-	
-  
-  <target name="dist" depends="compile,site">
-	<!-- jars -->
-	<unjar dest="build">
-		<fileset refid="josm_required_libs" />
-	</unjar>
-	<!-- images -->
-	<copy todir="build/images">
-		<fileset dir="images" />
-	</copy>
-
-  	
-    
-    <exec append="false" output="REVISION" executable="svn" failifexecutionfails="false">
-      <env key="LANG" value="C"/>
-      <arg value="info"/>
-      <arg value="--xml"/>
-      <arg value="."/>
-    </exec>
-    <xmlproperty file="REVISION" prefix="version" keepRoot="false" collapseAttributes="true"/>
-    <delete file="REVISION"/>
-    <!-- create jar file -->
-    <jar destfile="${plugin.jar}" basedir="${plugin.build.dir}">
-      <manifest>
-        <attribute name="Plugin-Class" value="${plugin.class}" />
-        <attribute name="Plugin-Description" value="${plugin.description}" />
-        <attribute name="Plugin-Stage" value="${plugin.stage}" />
-        <attribute name="Plugin-Version" value="${version.entry.commit.revision}"/>
-        <attribute name="Plugin-Date" value="${version.entry.commit.date}"/>
-        <attribute name="Plugin-Mainversion" value="1180" />
+<!-- josm "user home" directory depends on the platform used (windows has a different place than unix/linux) -->
+    <property environment="env"/>
+    <condition property="josm.home.dir" value="${env.APPDATA}/JOSM" else="${user.home}/.josm">
+        <and>
+            <os family="windows"/>
+        </and>
+    </condition>
+<!-- compilation properties -->
+    <property name="josm.build.dir"   value="../../core"/>
+    <property name="josm.plugins.dir" value="${josm.home.dir}/plugins"/>
+    <property name="josm"         location="../../core/dist/josm-custom.jar" />
+    <property name="plugin.build.dir" value="build"/>
+    <property name="plugin.dist.dir"  value="../../dist"/>
+    <property name="plugin.name"      value="${ant.project.name}"/>
+    <property name="plugin.jar"       value="../../dist/${plugin.name}.jar"/>
+    <property name="livegpsplugin.jar" value="../../dist/livegps.jar"/>
+    <property name="plugin.description" value="Adds support for TCX files."/>
+    <property name="plugin.stage" value="100"/>
+    <property name="plugin.class" value="org.openstreetmap.josm.plugins.TcxPlugin"/>
+<!-- update site meta data -->
+    <property name="plugin.site.file" value="josm-site.xml"/>
+    <property name="plugin.site.description" value=""/>
+    <property name="plugin.site.url" value=""/>
+    <property name="plugin.site.upload.target" value=""/>
+    <property name="ant.build.javac.target" value="1.5"/>
+<!-- All jar files necessary to run only JOSM (no tests) -->
+    <fileset id="josm_required_libs" dir="lib"></fileset>
+    <target name="dist" depends="compile,site">
+<!-- jars -->
+        <unjar dest="build">
+            <fileset refid="josm_required_libs" />
+        </unjar>
+<!-- images -->
+        <copy todir="build/images">
+            <fileset dir="images" />
+        </copy>
+        <exec append="false" output="REVISION" executable="svn" failifexecutionfails="false">
+            <env key="LANG" value="C"/>
+            <arg value="info"/>
+            <arg value="--xml"/>
+            <arg value="."/>
+        </exec>
+        <xmlproperty file="REVISION" prefix="version" keepRoot="false" collapseAttributes="true"/>
+        <delete file="REVISION"/>
+<!-- create jar file -->
+        <jar destfile="${plugin.jar}" basedir="${plugin.build.dir}">
+            <manifest>
+                <attribute name="Plugin-Class" value="${plugin.class}" />
+                <attribute name="Plugin-Description" value="${plugin.description}" />
+                <attribute name="Plugin-Stage" value="${plugin.stage}" />
+                <attribute name="Plugin-Version" value="${version.entry.commit.revision}"/>
+                <attribute name="Plugin-Date" value="${version.entry.commit.date}"/>
+                <attribute name="Plugin-Mainversion" value="1180" />
 <!--        <attribute name="Class-Path" value="lib/jaxb-api.jar;lib/jaxb-impl.jar" />-->
-      </manifest>
-    </jar>
-  </target>
-
-  <target name="compile" depends="init">
-    <echo message="creating ${plugin.jar}"/>
-    <mkdir dir="${plugin.build.dir}"/>
-    <javac srcdir="src" destdir="${plugin.build.dir}" debug="true" source="1.5" target="1.5">
-      <classpath>
-		<pathelement path="${josm.build.dir}/build"/>
-		<fileset dir="${josm.build.dir}/lib">
-	  		<include name="**/*.jar"/>
-		</fileset>
-		<fileset dir="./lib">
-	  		<include name="**/*.jar"/>
-		</fileset>
-      </classpath>
-    </javac>
-  </target>
-  
-  <target name="install" depends="dist">
-    <copy file="${plugin.jar}" todir="${josm.plugins.dir}"/>
-  </target>
-
-  <target name="init">
-    <echo>java version: ${java.version}</echo>
-  </target>
-
-  <target name="clean">
-    <delete dir="${plugin.build.dir}" />
-    <delete dir="${plugin.site.file}" />
-    <delete file="${plugin.jar}" />
-  </target>
-
-  <!-- write site description for the given plugin so josm will accept it -->
-  <target name="site">
-    <echo message="creating site description in ${plugin.site.file}"/>
-    <echo file="${plugin.site.file}">&lt;!-- plugins available on this site -->
+            </manifest>
+        </jar>
+    </target>
+    <target name="compile" depends="init">
+        <echo message="creating ${plugin.jar}"/>
+        <mkdir dir="${plugin.build.dir}"/>
+        <javac srcdir="src" destdir="${plugin.build.dir}" debug="true" source="1.5" target="1.5">
+            <classpath>
+                <pathelement path="${josm.build.dir}/build"/>
+                <fileset dir="${josm.build.dir}/lib">
+                    <include name="**/*.jar"/>
+                </fileset>
+                <fileset dir="./lib">
+                    <include name="**/*.jar"/>
+                </fileset>
+            </classpath>
+        </javac>
+    </target>
+    <target name="install" depends="dist">
+        <copy file="${plugin.jar}" todir="${josm.plugins.dir}"/>
+    </target>
+    <target name="init">
+        <echo>java version: ${java.version}</echo>
+    </target>
+    <target name="clean">
+        <delete dir="${plugin.build.dir}" />
+        <delete dir="${plugin.site.file}" />
+        <delete file="${plugin.jar}" />
+    </target>
+<!-- write site description for the given plugin so josm will accept it -->
+    <target name="site">
+        <echo message="creating site description in ${plugin.site.file}"/>
+        <echo file="${plugin.site.file}">&lt;!-- plugins available on this site -->
   &lt;plugins>
   &lt;plugin id="${ant.project.name}" version="${plugin.version}">
@@ -113,10 +95,9 @@
   &lt;/plugins>
 </echo>
-</target>
-
+    </target>
 <!-- write site description for the given plugin (not implemented in JOSM as full version yet!) -->
-<target name="site-full-donotuse">
-  <echo message="creating site description in ${plugin.site.file}"/>
-  <echo file="${plugin.site.file}">&lt;?xml version="1.0"?>
+    <target name="site-full-donotuse">
+        <echo message="creating site description in ${plugin.site.file}"/>
+        <echo file="${plugin.site.file}">&lt;?xml version="1.0"?>
     &lt;site version="1.0">
     &lt;!-- meta data of site -->
@@ -139,16 +120,13 @@
 &lt;/site>
 </echo>
-</target>
-
-
+    </target>
 <!-- upload the site description and the jar file via ssh -->
-<target name="upload" depends="dist,site">
-  <echo message="uploading jar and site description to ${plugin.site.upload.target}"/>
-  <exec executable="scp">
-    <arg value="${plugin.jar}"/>
-    <arg value="${plugin.site.file}"/>
-    <arg value="${plugin.site.upload.target}"/>
-  </exec>
-</target>
-
+    <target name="upload" depends="dist,site">
+        <echo message="uploading jar and site description to ${plugin.site.upload.target}"/>
+        <exec executable="scp">
+            <arg value="${plugin.jar}"/>
+            <arg value="${plugin.site.file}"/>
+            <arg value="${plugin.site.upload.target}"/>
+        </exec>
+    </target>
 </project>