Index: trunk/src/org/openstreetmap/josm/tools/HttpClient.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/HttpClient.java	(revision 12830)
+++ trunk/src/org/openstreetmap/josm/tools/HttpClient.java	(revision 12841)
@@ -45,10 +45,10 @@
     private URL url;
     private final String requestMethod;
-    private int connectTimeout = (int) TimeUnit.SECONDS.toMillis(Main.pref.getInteger("socket.timeout.connect", 15));
-    private int readTimeout = (int) TimeUnit.SECONDS.toMillis(Main.pref.getInteger("socket.timeout.read", 30));
+    private int connectTimeout = (int) TimeUnit.SECONDS.toMillis(Main.pref.getInt("socket.timeout.connect", 15));
+    private int readTimeout = (int) TimeUnit.SECONDS.toMillis(Main.pref.getInt("socket.timeout.read", 30));
     private byte[] requestBody;
     private long ifModifiedSince;
     private final Map<String, String> headers = new TreeMap<>(String.CASE_INSENSITIVE_ORDER);
-    private int maxRedirects = Main.pref.getInteger("socket.maxredirects", 5);
+    private int maxRedirects = Main.pref.getInt("socket.maxredirects", 5);
     private boolean useCache;
     private String reasonForRequest;
Index: trunk/src/org/openstreetmap/josm/tools/ImageProvider.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/ImageProvider.java	(revision 12830)
+++ trunk/src/org/openstreetmap/josm/tools/ImageProvider.java	(revision 12841)
@@ -122,13 +122,13 @@
     public enum ImageSizes {
         /** SMALL_ICON value of an Action */
-        SMALLICON(Main.pref.getInteger("iconsize.smallicon", 16)),
+        SMALLICON(Main.pref.getInt("iconsize.smallicon", 16)),
         /** LARGE_ICON_KEY value of an Action */
-        LARGEICON(Main.pref.getInteger("iconsize.largeicon", 24)),
+        LARGEICON(Main.pref.getInt("iconsize.largeicon", 24)),
         /** map icon */
-        MAP(Main.pref.getInteger("iconsize.map", 16)),
+        MAP(Main.pref.getInt("iconsize.map", 16)),
         /** map icon maximum size */
-        MAPMAX(Main.pref.getInteger("iconsize.mapmax", 48)),
+        MAPMAX(Main.pref.getInt("iconsize.mapmax", 48)),
         /** cursor icon size */
-        CURSOR(Main.pref.getInteger("iconsize.cursor", 32)),
+        CURSOR(Main.pref.getInt("iconsize.cursor", 32)),
         /** cursor overlay icon size */
         CURSOROVERLAY(CURSOR),
@@ -142,5 +142,5 @@
          * @since 8323
          */
-        LAYER(Main.pref.getInteger("iconsize.layer", 16)),
+        LAYER(Main.pref.getInt("iconsize.layer", 16)),
         /** Toolbar button icon size
          * @since 9253
@@ -150,14 +150,14 @@
          * @since 9253
          */
-        SIDEBUTTON(Main.pref.getInteger("iconsize.sidebutton", 20)),
+        SIDEBUTTON(Main.pref.getInt("iconsize.sidebutton", 20)),
         /** Settings tab icon size
          * @since 9253
          */
-        SETTINGS_TAB(Main.pref.getInteger("iconsize.settingstab", 48)),
+        SETTINGS_TAB(Main.pref.getInt("iconsize.settingstab", 48)),
         /**
          * The default image size
          * @since 9705
          */
-        DEFAULT(Main.pref.getInteger("iconsize.default", 24)),
+        DEFAULT(Main.pref.getInt("iconsize.default", 24)),
         /**
          * Splash dialog logo size
@@ -1013,10 +1013,10 @@
      */
     private static ImageResource getIfAvailableWiki(String name, ImageType type) {
-        final Collection<String> defaultBaseUrls = Arrays.asList(
+        final List<String> defaultBaseUrls = Arrays.asList(
                 "https://wiki.openstreetmap.org/w/images/",
                 "https://upload.wikimedia.org/wikipedia/commons/",
                 "https://wiki.openstreetmap.org/wiki/File:"
                 );
-        final Collection<String> baseUrls = Main.pref.getCollection("image-provider.wiki.urls", defaultBaseUrls);
+        final Collection<String> baseUrls = Main.pref.getList("image-provider.wiki.urls", defaultBaseUrls);
 
         final String fn = name.substring(name.lastIndexOf('/') + 1);
Index: trunk/src/org/openstreetmap/josm/tools/PlatformHookUnixoid.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/PlatformHookUnixoid.java	(revision 12830)
+++ trunk/src/org/openstreetmap/josm/tools/PlatformHookUnixoid.java	(revision 12841)
@@ -51,5 +51,5 @@
     @Override
     public void openUrl(String url) throws IOException {
-        for (String program : Main.pref.getCollection("browser.unix",
+        for (String program : Main.pref.getList("browser.unix",
                 Arrays.asList("xdg-open", "#DESKTOP#", "$BROWSER", "gnome-open", "kfmclient openURL", "firefox"))) {
             try {
Index: trunk/src/org/openstreetmap/josm/tools/Shortcut.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Shortcut.java	(revision 12830)
+++ trunk/src/org/openstreetmap/josm/tools/Shortcut.java	(revision 12841)
@@ -170,5 +170,5 @@
     // create a shortcut object from an string as saved in the preferences
     private Shortcut(String prefString) {
-        List<String> s = new ArrayList<>(Main.pref.getCollection(prefString));
+        List<String> s = new ArrayList<>(Main.pref.getList(prefString));
         this.shortText = prefString.substring(15);
         this.longText = s.get(0);
@@ -182,5 +182,5 @@
 
     private void saveDefault() {
-        Main.pref.getCollection("shortcut.entry."+shortText, Arrays.asList(longText,
+        Main.pref.getList("shortcut.entry."+shortText, Arrays.asList(longText,
             String.valueOf(requestedKey), String.valueOf(requestedGroup), String.valueOf(requestedKey),
             String.valueOf(getGroupModifier(requestedGroup)), String.valueOf(true), String.valueOf(false)));
@@ -190,7 +190,7 @@
     private boolean save() {
         if (isAutomatic() || isReset() || !isAssignedUser()) {
-            return Main.pref.putCollection("shortcut.entry."+shortText, null);
+            return Main.pref.putList("shortcut.entry."+shortText, null);
         } else {
-            return Main.pref.putCollection("shortcut.entry."+shortText, Arrays.asList(longText,
+            return Main.pref.putList("shortcut.entry."+shortText, Arrays.asList(longText,
                 String.valueOf(requestedKey), String.valueOf(requestedGroup), String.valueOf(assignedKey),
                 String.valueOf(assignedModifier), String.valueOf(assignedDefault), String.valueOf(assignedUser)));
Index: trunk/src/org/openstreetmap/josm/tools/TextTagParser.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/TextTagParser.java	(revision 12830)
+++ trunk/src/org/openstreetmap/josm/tools/TextTagParser.java	(revision 12841)
@@ -20,6 +20,6 @@
 
     // properties need JOSM restart to apply, modified rarely enough
-    private static final int MAX_KEY_LENGTH = Main.pref.getInteger("tags.paste.max-key-length", 50);
-    private static final int MAX_KEY_COUNT = Main.pref.getInteger("tags.paste.max-key-count", 30);
+    private static final int MAX_KEY_LENGTH = Main.pref.getInt("tags.paste.max-key-length", 50);
+    private static final int MAX_KEY_COUNT = Main.pref.getInt("tags.paste.max-key-count", 30);
     private static final String KEY_PATTERN = Main.pref.get("tags.paste.tag-pattern", "[0-9a-zA-Z:_]*");
     private static final int MAX_VALUE_LENGTH = 255;
Index: trunk/src/org/openstreetmap/josm/tools/Utils.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Utils.java	(revision 12830)
+++ trunk/src/org/openstreetmap/josm/tools/Utils.java	(revision 12841)
@@ -1246,5 +1246,5 @@
      */
     public static ForkJoinPool newForkJoinPool(String pref, final String nameFormat, final int threadPriority) {
-        int noThreads = Main.pref.getInteger(pref, Runtime.getRuntime().availableProcessors());
+        int noThreads = Main.pref.getInt(pref, Runtime.getRuntime().availableProcessors());
         return new ForkJoinPool(noThreads, new ForkJoinPool.ForkJoinWorkerThreadFactory() {
             final AtomicLong count = new AtomicLong(0);